=== debian/changelog ===
pd-hid (0.7-6) unstable; urgency=medium

  * Modernize 'licensecheck' target
    + Ensure that 'licensecheck' is run with the C.UTF-8 locale
    + Exclude debian/ from 'licensecheck'
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 07 Dec 2022 10:43:35 +0100

pd-hid (0.7-5) unstable; urgency=medium
  [ IOhannes m zmölnig (Debian/GNU) ]
  * Modernize 'licensecheck' target
    + Re-generated d/copyright_hints

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Bug-Database.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 26 Nov 2022 23:55:42 +0100

pd-hid (0.7-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Removed Hans-Christoph Steiner from Uploaders as he requested
  * Add salsa-ci configuration
  * Remove obsolete file d/source/local-options
  * Declare that building this package does not require 'root' powers.
  * Apply "warp-and-sort -ast"
  * Bump dh-compat to 13
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 04 Sep 2022 13:42:27 +0200

pd-hid (0.7-3) unstable; urgency=medium

  * Patch to fix printf format violations
  * Simplified & unified d/rules
    * Bumped dh compat to 11
    * Enabled hardening
    * Fixed reproducible-build regression
  * Updated Vcs-* stanzas to salsa.d.o
  * Updated maintainer address
  * Switched URLs to https://
  * Updated d/copyright(_hints)
  * Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 01 Feb 2018 23:08:35 +0100

pd-hid (0.7-2) unstable; urgency=medium

  [ Hans-Christoph Steiner ]
  * Depends: puredata-core | pd, so the depends is not only on a virtual package
  * bumped Standards-Version to 3.9.3
  * updated to copyright-format/1.0
  * remove 'DM-Upload-Allowed: yes', its deprecated

  [ IOhannes m zmölnig ]
  * Made build reproducible
  * Updated Vcs-* stanzas to canonical https:// URLs
  * d/copyright
    * added debian/* section
    * Fixed license shortname
    * Fixed "Files:" section for "HID Utilities Source"
  * Bumped to standards version 3.9.8
  * Added myself to uploaderes

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 10 Jun 2016 22:34:22 +0200

pd-hid (0.7-1) unstable; urgency=low

  * Initial release (Closes: #607764)

 -- Hans-Christoph Steiner <hans@eds.org>  Sat, 11 Jun 2011 18:24:12 -0400
