=== debian/control ===
Source: pd-hid
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 puredata-dev | puredata (<< 0.43),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://puredata.info
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-hid.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-hid

Package: pd-hid
Architecture: any
Depends:
 pd-mapping,
 puredata-core | pd,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pd-pddp,
Description: Pd object for getting data from USB HID devices
 [hid] is a Pure Data object for reading data from USB HID devices like
 keyboards, mice, joysticks, gamepads, keypads, and all sorts of other
 esoteric controllers like USB knobs, touchscreens, Apple IR Remotes, etc. It
 represents the data with a cross-platform message scheme which is then
 translated to the underlying native API for input devices (Linux input.h or
 Mac OS X HID Utilities).
