=== debian/watch ===
version=3
https://sf.net/pure-data/hid-(.*)\.tar\.gz
